import { DependencyConstructor, Factory, NameSelector } from '../types';
import { ILifetime } from '../Lifetime';
export declare type LifetimeConstructor<T, E> = new (name: string, factoryFunction: Factory<T, Required<E>>) => ILifetime<T, E>;
export declare type ProviderConstructor<E> = {
    prototype: E;
    name: string;
    new (): E;
};
export declare type DependencyOptions<T, E> = {
    dependency?: undefined;
    factory: Factory<T, E>;
    selector: NameSelector<T, Required<E>>;
} | {
    dependency: DependencyConstructor<T, Required<E>>;
    factory?: Factory<T, Required<E>>;
    selector?: NameSelector<T, Required<E>>;
} | DependencyConstructor<T, Required<E>>;
