import { IServiceCollection } from '../ServiceCollection';
import { NameSelector, ProviderFactory, ProviderScope, ProviderValidation } from '../types';
import { ProviderContext } from './types';
import { IServiceProvider } from './IServiceProvider';
export declare class InternalServiceProvider<E> implements IServiceProvider<E> {
    readonly _: ProviderContext<E>;
    constructor(container: IServiceCollection<E>, create: ProviderFactory<E>, validation: ProviderValidation, context: ProviderScope);
    getService<T>(nameSelector: NameSelector<T, Required<E>>): T;
}
export declare type ServiceProvider<E> = Required<E> & InternalServiceProvider<E>;
