"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InternalServiceProvider = void 0;
var Errors_1 = require("../Errors");
var InternalServiceProvider = /** @class */ (function () {
    function InternalServiceProvider(container, create, validation, context) {
        Object.defineProperty(this, "_", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this._ = {
            scope: context,
            validation: validation,
            container: container,
            create: create,
        };
    }
    Object.defineProperty(InternalServiceProvider.prototype, "getService", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (nameSelector) {
            var _a;
            var _b = this._, container = _b.container, scope = _b.scope, create = _b.create, validation = _b.validation;
            var name = container.resolveProperty(nameSelector);
            try {
                var actual = scope ? this : create(validation, {});
                return (_a = container.get(name)) === null || _a === void 0 ? void 0 : _a.provide(actual);
            }
            catch (e) {
                var error = e;
                switch (error.type) {
                    case Errors_1.DependencyErrorType.Circular:
                        // When error is detected we can only say lifetime === cause
                        // Letting it throw 1 dependency up we can find the dependencies causing the issue
                        if (error.lifetime !== error.cause)
                            throw e;
                        throw new Errors_1.CircularDependencyError(error.lifetime, name);
                    default:
                        throw e;
                }
            }
        }
    });
    return InternalServiceProvider;
}());
exports.InternalServiceProvider = InternalServiceProvider;
