import { Keys } from './utils';
import { ServiceProvider } from './index';
export declare type Factory<T, E> = (provider: E) => T;
export declare type ProviderValidation = {
    lastSingleton?: string;
    trail: Record<string, boolean>;
    validate: boolean;
};
export declare type ProviderScope = Record<string, any>;
export declare type ProviderFactory<E> = (validation: ProviderValidation, context: ProviderScope) => ServiceProvider<E>;
export declare type DependencyConstructor<T, E> = {
    prototype: T;
    name: string;
    new (provider: E): T;
} | {
    prototype: T;
    name: string;
    new (): T;
};
export declare type NameSelector<T, E> = string | ((p: Keys<T, E>) => string);
